﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FolderStructureWithXamDataTree
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            var dataSource = new clsItem() { Name = "Main Category" };
            var children = dataSource.ChildItems = new List<INode>() 
            { 
                new clsItem() { Name = "Sub Category Menus" },
                new clsItem()
                {
	                Name = "Sub Category Tasks", ChildItems = new List<INode>()
	                {
		                new clsItem()
		                {
			                Name = "Main Menus", ChildItems = new List<INode>()
			                {
				                new clsSubItem(){Name = "Delete Entity", Code="xyz"},
								new clsSubItem(){Name="Modify Entity", Code="mno"}
			                }
		                },
						new clsItem(){Name = "Temporary Menus"}
	                }
                }, 
                new clsItem() { Name = "Sub Category Forms", ChildItems = new List<INode>()
                {
	                new clsSubItem(){Name = "Authorize Entity", Code = "abc"},
					new clsSubItem(){Name = "Create Entity", Code = "def"}
                } 
				}
            };
			children.AddRange(new List<clsSubItem>() 
            {
                new clsSubItem(){Name = "Authorize Entity", Code = "10 MB"},
                new clsSubItem(){Name = "Form One", Code = "5 MB"},
                new clsSubItem(){Name = "Form Two", Code = "18 MB"},
            });

            folderTree.ItemsSource = new List<clsItem>() {dataSource};

        }
    }

    public interface INode
    {
		int Id { get; set; }
		string Name { get; set; }
        bool IsMenu { get; }
        bool IsPermission { get; }
		bool? IsSelected { get; set; }
        List<INode> ChildItems { get; set; }
    }

    public class clsItem : INode
    {
		public int Id { get; set; }
		public string Name { get; set; }
		public bool? IsSelected { get; set; }
        public List<INode> ChildItems { get; set; }

        public bool IsMenu
        {
            get
            {
                return true;
            }
        }
        public bool IsPermission
        {
            get { return false; }
        }
    }

    public class clsSubItem : INode
    {
		public int Id { get; set; }
		public string Name { get; set; }
        public string Code { get; set; }
		public bool? IsSelected { get; set; }
        public bool IsMenu
        {
            get { return false; }
        }

        public bool IsPermission
        {
            get { return true; }
        }


        public List<INode> ChildItems
        {
            get
            {
                return null;
            }
            set
            {
                throw new NotImplementedException();
            }
        }
    }

	public class NodeToMenuConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value as clsItem;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class NodeToPermissionConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value as clsSubItem;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


}
