﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Xml.Serialization

Public Class GlobalClass
	
	Public Enum SubItemType
		TypeA = 0
		TypeB = 1
	End Enum
	
End Class
Public Class clsItem
	Implements INotifyPropertyChanged 
	
	Private _ID As Integer = Nothing
	Private _ParentID As Integer = Nothing
	Private _Description As String = Nothing
	Private _SubItem As clsSubItem = Nothing
	Private _IsExpanded As Boolean = False
	Private _IsSelected As Nullable(Of Boolean) = False

	Private _IsTypeA As Boolean = False
	Private _IsTypeB As Boolean = False

	Private _ChildItems As ObservableCollection(Of clsItem) = Nothing
	Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

	Protected Overridable Sub OnPropertyChanged(propertyName As String)
		RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
	End Sub

	<XmlAttribute()>
	Public Property ID As Integer
	Get
		Return Me._ID
	End Get
	Set(InValue As Integer)
		Me._ID = InValue
		OnPropertyChanged("ID")
	End Set
	End Property
	
	<XmlAttribute()>
	Public Property ParentID As Integer
	Get
		Return Me._ParentID
	End Get
	Set(InValue As Integer)
		Me._ParentID = InValue
		OnPropertyChanged("ParentID")
	End Set
	End Property

	<XmlAttribute()>
	Public Property Description As String
	Get
		Return Me._Description
	End Get
	Set(InValue As String)
		Me._Description = InValue
		OnPropertyChanged("Description")
	End Set
	End Property

	<XmlAttribute()>
	Public Property SubItem As clsSubItem
	Get
		Return Me._SubItem
	End Get
	Set(InValue As clsSubItem)
		Me._SubItem = InValue
		OnPropertyChanged("SubItem")
	End Set
	End Property
	
	<XmlAttribute()>
	Public Property IsExpanded As Boolean
	Get
		Return Me._IsExpanded
	End Get
	Set(InValue As Boolean)
		Me._IsExpanded = InValue
		Try
			Me.OnPropertyChanged("IsExpanded")
		Catch
			' This is required as collapsing the node throws an error.
		End Try
	End Set
	End Property

	<XmlAttribute()>
	Public Property IsSelected As Nullable(Of Boolean)
	Get
		Return Me._IsSelected
	End Get
	Set(InValue As Nullable(Of Boolean))
		Me._IsSelected = InValue
		Try
			Me.OnPropertyChanged("IsSelected")
		Catch
			' This is required as unchecking the node throws an error.
		End Try
	End Set
	End Property

	<XmlAttribute()>
	Public Property IsTypeA As Boolean
	Get
		Return Me._IsTypeA
	End Get
	Set(InValue As Boolean)
		Me._IsTypeA = InValue
	End Set
	End Property

	<XmlAttribute()>
	Public Property IsTypeB As Boolean
	Get
		Return Me._IsTypeB 
	End Get
	Set(InValue As Boolean)
		Me._IsTypeB = InValue
	End Set
	End Property

	Public Property ChildItems As ObservableCollection(Of clsItem)
	Get
		If Me._ChildItems Is Nothing Then
			Me._ChildItems = New ObservableCollection(Of clsItem)
		End If

		Return Me._ChildItems
	End Get
	Set(InValue As ObservableCollection(Of clsItem))
		Me._ChildItems = InValue
		OnPropertyChanged("ChildItems")
	End Set
	End Property

End Class

Public Class clsSubItem
	Implements INotifyPropertyChanged 

	Private _ID As Integer = Nothing
	Private _Code As String = Nothing
	Private _Description As String = Nothing
	Private _Type As GlobalClass.SubItemType = Nothing
	Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

	Protected Overridable Sub OnPropertyChanged(propertyName As String)
		RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
	End Sub

	<XmlAttribute()>
	Public Property ID As Integer
	Get
		Return Me._ID
	End Get
	Set(InValue As Integer)
		Me._ID = InValue
		OnPropertyChanged("ID")
	End Set
	End Property

	<XmlAttribute()>
	Public Property Code As String
	Get
		Return Me._Code
	End Get
	Set(InValue As String)
		Me._Code = InValue	
		OnPropertyChanged("Code")
	End Set
	End Property

	<XmlAttribute()>
	Public Property Description As String
	Get
		Return Me._Description
	End Get
	Set(InValue As String)
		Me._Description = InValue
		OnPropertyChanged("Description")
	End Set
	End Property

	<XmlAttribute()>
	Public Property Type As GlobalClass.SubItemType 
	Get
		Return Me._Type
	End Get
	Set(InValue As GlobalClass.SubItemType)
		Me._Type = InValue
		OnPropertyChanged("Type")
	End Set
	End Property

End Class

Public Class clsSubItemA
	Inherits clsSubItem 

End Class

Public Class clsSubItemB
	Inherits clsSubItem
End Class

